//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>
#include <math.h>
#include <time.h>

#include "nasino_ke.h"

#define DicBufferLength			32768
//#define AnswerLength			DicBufferLength
#define AnswerLength			10240
#define DataLength				DicBufferLength			
#define WordLength				4096
#define AnswerHeaderLength		128

#define SentenceRandbuf			10		// sentence̓ꕶ̘Aǂݏo`FbNpOobt@

#define TAGLIST_MAX		32
#define NEST_MAX		99

#define SAKURA_MAPDATMAX	16

#define	ON		1
#define	OK		1
#define	OFF		0
#define	NG		0

#define		NASINO_TAG			"nasino"
#define		KAWARI_TAG			"kawari"
#define		START_TAG0			"${"
#define		END_TAG0			"}"
#define		START_TAG1			'$'
#define		START_TAG2			'{'
#define		END_TAG				'}'
#define		END_TAG2			"}"
#define		KIS_START_TAG1		'('
#define		KIS_END_TAG			')'
#define		KIS_END_TAG2		")"
#define		FROM_TAG			"from"
#define		TO_TAG				"to"
#define		SENTENCE_TAG		"sentence"
#define		EVENT_TAG			"event"
#define		ENTRY_ANYONE		"anyone"

#define		S20_Separater		{0x0d,0x0a,'\0'}


#define		SAKURA_NAMETAG		"sakura.name"
#define		SAKURA_NAMETAG2		"sakura.name2"
#define		KERO_NAMETAG		"kero.name"
#define		FRIEND_NAMETAG		"sakura.friend.name"
#define		USER_NAMETAG		"user.defaultname"

//#define		SAKURA_DEFNAME	""
//#define		KERO_DEFNAME	"ɂイ"
//#define		FRIEND_DEFNAME	""				/* ł킯˂ȁB */
#define		USER_DEFNAME		"%username"			/* [ǓĂі */
#define		SAKURA_DEFNAME		"%selfname"			/* ϊɂ܂ */
#define		SAKURA_DEFNAME2		"%selfname2"		/* ϊɂ܂ */
#define		KERO_DEFNAME		"%keroname"			/* ϊɂ܂ */
#define		FRIEND_DEFNAME		"%friendname"		/* ϊɂ܂ */

/* ϊp */
#define		MYNAME				"myname"
#define		UNYUNAME			"unyuname"

#define		COMPATIBLE_CODE		"compatible-"
#define		COMPATIBLE_CODELEN	11



#define INI_FILENAME			"nasino.ini"		/* ̒`t@C */
#define INI_FILENAME1			"nasino.ini"		/* ̒`t@C */
#define INI_FILENAME2			"kawari.ini"		/* ̒`t@C */
#define DESCRIPT_FILENAME		"descript.txt"		/* ghost̒`t@C */
#define TESTLOG_FILENAME		"nasino.log"		/* TEST LOG */
#define SCRIPTLOG_FILENAME		"script.log"		/* nasino scriptLOG */

/* nasino.ini */
#define Com_DICT				1
#define Com_RANDOMSEED			2
#define Com_LOG					3
#define Com_DEBUG				4
#define Com_TALK_INTERVAL		5
#define Com_SCRIPT_LOG			6
#define Com_SCRIPT				7

// ̎
#define DicType_Sakura			1
#define DicType_Kawari			2
#define DicType_Nasino			3

// SHIORI/2.0R}h
#define SHIORI_TEST				0
#define NOTIFY					1
#define GET_Version				2
#define GET_Sentence			3
#define GET_Word				4
#define GET_Status				5
#define COMMUNICATE_Sentence 	6
#define NOTIFY_OtherGhostName	7
#define GET_String				8

#define S20_Sender		0
#define S20_Ghost		1
#define S20_Charset		2
#define S20_Word		3
#define S20_Sentence	4
#define S20_Type		5
#define S22_Event		6
#define S25_ID			7

#define LineDecodeNum	8

#define ReferenceNum	8

#define S23_AGE			"Age:"
#define S23_GHOST		"Ghost:"
#define S23_GHOSTEX		"GhostEx:"

#define REQUEST_Header_GHOST	"Ghost"
#define REQUEST_Header_GHOSTEX	"GhostEx"

// Nasino InLine Script Command
#define NIS_SET				"set"
#define NIS_NASINO_EVENT	"nasino_event"
#define NIS_Command_To		"Command.To"

// 삩̃VXeg[Np^O
#define ST_NoOtherGhost		"${ST.NoOtherGhost}"	// ̃S[Xg͂Ȃ

// logic_make()샂[h
#define LOGIC_STRCMP	0
#define LOGIC_STRSTR	1

struct dic_data{		/* ẽ|C^ */
	unsigned int wordnumber;			/* ̔ԍ */
	char *key;							/* L[ */
	char *word;							/* g */
	unsigned short dicnumber;			/* ԍ */
	unsigned short attribute;				/*  */
	unsigned short katuyou;					/* p */
	unsigned short kaku;					/* i */
	unsigned short type1;					/* iƂ̑ */
	
};

struct dic_readdata{	/* ǂݏof[^ */
	unsigned int wordnumber;			/* P̔ԍ */
	char key[WordLength];				/* L[ */
	char word[WordLength];				/* g */
	unsigned short dicnumber;			/* ԍ */
	unsigned short attribute;				/*  */
	unsigned short katuyou;					/* p */
	unsigned short kaku;					/* i */
	unsigned short type1;					/* iƂ̑ */
};

struct comm11_data{		/* SHIORI COMMUNICATE/1.1pf[^ */
	char code[WordLength];				/* ʃR[h */
	char script[WordLength];			/*  */
	char sender[WordLength];			/*  */
	int age;							/*  */
	char targetHWnd[WordLength];		/*  */
};

struct S23_ghost{		// SHIORI/2.3 Sender List
	char *ghost_name;					// O
	S23_ghost *next_pointer;			// ̃f[^ւ̃|C^
	int sakura_surface;					// sakurãT[tFCX
	int kero_surface;					// kerõT[tFCX
};

struct s20_data{		// SHIORI/2.0pf[^
	int code;							/* R}h */
	int version;						/* SHIORI R}ho[W */
	char buffer[WordLength];
	char sender[WordLength];			/* M */
//	S23_ghost *ghost_pointer;			// S[XgList̃|C^
	char ghost[WordLength];				/* S[Xg */
	char charset[WordLength];			/* R[h */
	char word[WordLength];				/*  */
	char sentence[WordLength];			/*  */
	char type[WordLength];				/*  */
	int status[6];						/*  */
	char id[WordLength];				/* SHIORI/2.5 ID */
	int age;							/* SHIORI/2.3b */
	char to[WordLength];				/* SHIORI/2.3b ^[Qbg̃S[Xg̖O */
	char targetHWnd[WordLength];		/*  */
	char event[WordLength];				/*  */
	char reference0[WordLength];		/*  */
	char reference1[WordLength];		/*  */
	char reference2[WordLength];		/*  */
	char reference3[WordLength];		/*  */
	char reference4[WordLength];		/*  */
	char reference5[WordLength];		/*  */
	char reference6[WordLength];		/*  */
	char reference7[WordLength];		/*  */
};

struct ghost_data{
	char sakuraname[DataLength];
	char sakuraname2[DataLength];
	char keroname[DataLength];
	char friendname[DataLength];
	
	S23_ghost *ghost_pointer;			// S[XgList̃|C^
	int ghost_num;						// S[Xg̐l
	
	int ghosttalkinterval;				// AIg[NԊu(Sec)
	
	int neuron;							// AIOt
	int neuronm;
	int neuronk;
	int neurond;
	int neurone;
	int sysnapse;
};

struct ghost_memory{
	char sender[WordLength];
	char reference0[WordLength];		//
	char reference1[WordLength];		//
	char reference2[WordLength];		//
	char reference3[WordLength];		//
	char reference4[WordLength];		//
	char reference5[WordLength];		//
	char reference6[WordLength];		//
	char reference7[WordLength];		//
};

struct sakura_mapdat{	/* "Sakura" filemapping object */
	long hwnd;
//	char *name;
	char name[256];
};


struct taglist{			/* ${}tagp̃X^bN */
	char *data;
	int nest;
};


// nasino.cpp
void dic_ini(void);									/* ̏ */
void dic_unload(void);								/* ̗̈ */
int dic_read(void);									/* ǂݍ */
void dicread_tagchg(char* key);
int read_ini(char* ,char* );						/* nasino.ini ̓ǂݍ */
int get_dicname(char* ,char* );						/* t@C؂o */
int check_dictype(char *buffer);
int check_dicword(char *);
int get_inifilename(char* );						/* init@C̖O擾 */
long dicword_count(char* );							/* ̂Ps̗vfJEg */
long dicsize_count(char* );							/* ̂Ps̃TCYJEg */
int get_dicword(struct dic_readdata *,long );		/* Po */
int n_getword(char *,char *,int );					/* v̂Po */
int get_tagword(char *,char *);
int tagwordcount(char* tag,int *tag_table);
void make_sentence2(struct s20_data *answerdata,struct s20_data *commdata,int nest);
void make_sentence_new(char* answer,char* buffer,int nest);
void make_kiscode(struct s20_data *answerdata,char *buffer,int nest,struct s20_data *commdata);
//void make_kiscode(char *answer,char *buffer,int nest,struct s20_data *commdata);
//void make_kiscode(char *answer,char *buffer,int nest);
void make_tagcode(char *word,char *buffer,int);
void make_sentence(char* ,char* ,int );
int n_setupnametable(char* ,char* , char* );		/* descript.txt疼Oǂݍ */
int tagchange(char *,char *,int);					/* Œ^Oϊ */
int taglist_set(char *,int);						/* TAG̋L */
int taglist_get(char *,int ,int);					/* TAG̎o */
int taglist_free(int);								/* TAG̋L̈ */

int n_getmatchword(char *,char *);					/* ͂Ɋ܂܂鎫̒PoB */
char *s5wordmake(char *,char *);					/* System.5 dl?̕쐬B */
int get_sakuratag(char *,struct dic_readdata ,int);	/* keySAKURA^Oɋtϊ */
int check_compatiblecode(char *,char *);			/* COMPATIBLE_CODẼ`FbN */
int mach_dicword(char *,struct dic_readdata *,int);	/* w肳ꂽPƈvTB */
int chkmachword(char *,struct dic_readdata ,int *);	/* ͂ɒPꂪ܂܂Ă邩𒲂ׂB */
void n_getaistringfromtargetword(char *,char *);
int checktag2tag(char *,char *,int );
int s5worddecode(char *,char *);


char *DecryptString(char *);						/* Í */
int logwrite(char* );								/* log̏óiJpj */

//nasino_comu

//int n_getresponse(char *answer,char *buffer);
//int nasino_s22event(char *answer,struct s20_data commdata);				//  SHIORI/2.2 Event
int nasino_s22event(struct s20_data *answerdata,struct s20_data *commdata);
//int nasino_s22event(struct s20_data *answerdata,struct s20_data commdata);
int nasino_s20get_sentence(struct s20_data *answerdata,struct s20_data commdata);
int nasino_s21communicate(struct s20_data *answerdata,struct s20_data commdata);
int nasino_getghostname(char *ghostname,struct s20_data *commdata);
//int nasino_getghostname(char *ghostname,struct s20_data commdata);						// GhostName̎擾
int nasino_s23ghostcomminucate(struct s20_data *answerdata,struct s20_data *commdata);	// SHIORI/2.3b
int nasino_s23ghostcomminucate_new(struct s20_data *answerdata,struct s20_data *commdata);
int nasino_s20makeanswer(struct s20_data *answerdata,struct s20_data commdata);

int kawari5com(char *answer,char *buffer);
int logic_make(char *logic,char *input,char *buffer,unsigned int);
//int com11encode(char *answer,struct comm11_data commdata);
//int com11decode(struct comm11_data *commdata,char *buffer);
//int comu11decode_sender(char *word,char *buffer);
//int comu11decode_age(char *buffer);
int nasino_eventmachcount(int *tag_table,struct s20_data commdata,int mode);
int nasino_tagwordcount(char* tag,int *tag_table,int);
int s20diccheck_sentence(struct dic_readdata dicreaddata,struct s20_data *commdata);
int s20diccheck_from(struct dic_readdata dicreaddata,struct s20_data *commdata);
int s20diccheck_event(struct dic_readdata dicreaddata,struct s20_data *commdata);
int s20diccheck_to(struct dic_readdata dicreaddata,char *ghostname);
//int s20diccheck_to(struct dic_readdata dicreaddata,struct sakura_mapdat *sakura_object,int sakura_objpoint);

//int check_sakurafillemappingdata(struct sakura_mapdat *sakura_object,int *sakura_objpoint);
int s21gettargetghost(char *targetHWnd,struct dic_readdata dicreaddata,struct sakura_mapdat *sakura_object,int sakura_objpoint);

// nasino_request.cpp

int n_request(struct s20_data *answerdata,struct s20_data *commdata);
int request_comsentence(char* answer,struct s20_data commdata);
int request_test(struct s20_data *answerdata,struct s20_data *commdata);
int request_notify(struct s20_data *answerdata,struct s20_data *commdata);
int request_version(struct s20_data *answerdata);
int request_getstring(struct s20_data *answerdata,struct s20_data *commdata);
int request_getsentence(struct s20_data *answerdata,struct s20_data *commdata);
int request_getword(struct s20_data *answerdata,struct s20_data *commdata);
int request_getssatus(struct s20_data *answerdata,struct s20_data *commdata);
int request_answerheader_encode(char *answer,int version,int status);

int s20decode(struct s20_data *commdata,char *buffer);
int s20header_decode(struct s20_data *commdata,char *buffer);
int s20line_decode(struct s20_data *commdata,char *buffer,int com_number);
int s20age_decode(struct s20_data *commdata,char *buffer);
int s20reference_decode(struct s20_data *commdata,char *buffer);
int s23ghost_decode(struct s20_data *commdata,char *buffer);
void s23ghost_free(struct S23_ghost *ghost);
int s20_data_clear(struct s20_data *commdata);
//int s20charset_decode(struct s20_data *commdata,char *buffer);
int shiori_answer_encode(char *answer,struct s20_data answerdata,int type);
//int s22answer_encode(char *answer,struct s20_data answerdata);
//int s23answer_encode(char *answer,struct s20_data answerdata);

// nasino_ke.cpp

char *MakeKatuyo(struct dic_readdata ,int );		/* A`e̊p */
char *MkHira(char *, char *);						/* A`e̊p */


// nasino_sub.cpp


int getword_escape1(char *word,char *buffer,unsigned int *count1);
int getword_escape2(char *word,char *buffer,unsigned int *count1);
int getsignword(char *word,char *buffer);		/* _L؂o */
int getsignword_new(char *word,char *buffer);
int getcalcword(char *word,char *buffer);
int get01word(char *word,char *buffer);
int gettagword(char *word,char *buffer);
int getmarkword(char *word,char *buffer);
int getkeyword(char *word,char *buffer);
int getkeyword_one(char *word,char *buffer);
int getbufpword(char *word,char *buffer);
int getbufword_new(char *word,char *buffer);
int getbufword0d(char *word,char *buffer_point);
int getbufconditional(char *word,char *buffer_point);			/* []o */
int getbufentry(char *word,char *buffer_point);					/* {} */
int getbufword(char *,char *);					/* 񂩂o */
int getnumberword(char *word,char *buffer);
char getsym(char *);							/* V{1o */
int getsymsj(char *,char *);					// V{1؂o S-JISR[hΉ
int chksymsj(char *,char *);					// V{1o S-JISR[hΉ
void read_space(char *);						/* 󔒕ǂݔ΂ */
void str_toupper(char *,char *);				/* 啶ɕϊ */
int check_onoff(char *);						/* ON,OFFǂ炩ׂ */
void word_rspacecut(char *word);				/* wordI[̋󔒂폜 */
int logic_calc(char* word);
int nasino_random(int n);
int checksjcode(unsigned char sym);
char* strstr2(char* word,char* tagword);



