%{
#include "nasino.h"
#include "nasino_script.h"
/*#include "script_n.h"*/

#define YYMAXDEPTH 400

#define ID		100
#define NUM		101
#define STR		102
#define NON		103
#define STACK	104
#define DIM		105

#define NODESIZE	100
/*int nodecnt = 0;
struct node nodearea[NODESIZE] = {0};*/
extern tree codetree;

/*struct node
	{
	int ntype;
	int nvalue;
	struct node *left;
	struct node *right;
	} nodearea[NODESIZE] = {0};
*/


extern double answer;

extern int parse_line;   /* Ăsԍ */
extern symbol script_symbols;					// ϐi[̈
extern char LogTmp[AnswerLength];

int yyerror(char* s)
{
	extern int yylineno;

	/* G[bZ[W s ɓĂ̂ł\ */
	sprintf(LogTmp,"nasino script: %5ds %s\n",parse_line,s);
	script_logwrite(LogTmp);
	logwrite(LogTmp);

	printf("nasino script: %5ds %s\n",yylineno,s);

	return 1;
}


%}
%union
{
	int idno;
	int num;
	int pointer;
	int label;
	struct node *nodep;

  double dval;
  struct symbols* symp;
}
%token	<idno>		IDENT DIMM
%token	<num>		NUMBER
%token	<pointer>	STRING
%token	INT CHAR
%token	IF ELSE
%token	STRCPYOP STRCMPOP STRCATOP
%token	ATOIOP ITOAOP
%token	SSTPSENDOP GET_INITFILEDATAOP
%token	SAVEOP LOADOP SAORICALLOP
%token	DATEOP RANDOP
%token	LP RP LC RC LB RB
%token	SM CM
%token	ASGNOP
%token	EQOP GTOP GEOP GEOP LSOP LEOP NTOP
%left	ADDOP SUBOP
%left	MULOP DIVOP
%right	MINUS
%type	<label>	if_head 
%type	<nodep>	expr cond dimstr str st str3 stex stexst dim atoi itoa date strcpy strcmp strcat 
%type	<nodep>	sstpsend get_initfiledata save load rand saoricall
%%
statement_list
		: statement '\n' 
		| statement
		| statement_list statement '\n'
		| statement_list statement
		| '\n'
		;
statement
		: IDENT ASGNOP expr SM
			{
				codetree.call_codegenerater($3);
				codetree.clearnodearea();
				nasino_script_codegenerator(OP_POP, $1);
			}
		| if_head statement
			{
				nasino_script_codegenerator(OP_LBL, $1);
			}
		| if_head statement ELSE
			{
				nasino_script_codegenerator(OP_JP, $<label>$ = nasino_script_genlabel());
				nasino_script_codegenerator(OP_LBL, $1);
			}
		  statement
			{
				nasino_script_codegenerator(OP_LBL, $<label>4);
			}
		| INT IDENT ASGNOP expr SM
			{
				codetree.call_codegenerater($4);
				codetree.clearnodearea();
				nasino_script_codegenerator(OP_POP, $2);
			}
		| INT IDENT SM
			{
				script_symbols.set_symbol_type($2,TYPE_INT);
				codetree.clearnodearea();
			}
		| CHAR IDENT SM
			{
				script_symbols.set_symbol_type($2,TYPE_CHAR);
				codetree.clearnodearea();
			}
		| INT IDENT LB RB SM
			{
				script_symbols.set_symbol_type($2,TYPE_INTDIM);
				codetree.clearnodearea();
			}
		| CHAR IDENT LB RB SM
			{
				script_symbols.set_symbol_type($2,TYPE_CHARDIM);
				codetree.clearnodearea();
			}
		| strcpy SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| strcat SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| strcmp SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| sstpsend SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| get_initfiledata SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| atoi SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| itoa SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| date SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| rand SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| saoricall SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| save SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| load SM
			{
				codetree.call_codegenerater($1);
				codetree.clearnodearea();
			}
		| LC statement_list RC
		| LC RC
		| SM
		| error SM
			{
				yyerrok;
				codetree.clearnodearea();
			}
		| error RC
			{
				yyerrok;
				codetree.clearnodearea();
			}
		;
if_head
		: IF LP cond RP
			{
				codetree.call_codegenerater($3);
				codetree.clearnodearea();
				nasino_script_codegenerator(OP_JPZ, $$ = nasino_script_genlabel());
			}
		;
cond
		: expr EQOP expr	{ $$ = codetree.makebranch(EQ, $1, $3); }
		| expr GTOP expr	{ $$ = codetree.makebranch(GT, $1, $3); }
		| expr GEOP expr	{ $$ = codetree.makebranch(GE, $1, $3); }
		| expr LSOP expr	{ $$ = codetree.makebranch(LS, $1, $3); }
		| expr LEOP expr	{ $$ = codetree.makebranch(LE, $1, $3); }
		| expr NTOP expr	{ $$ = codetree.makebranch(NT, $1, $3); }
	;
expr	: expr ADDOP expr	{ $$ = codetree.makebranch(ADD, $1, $3); }
		| expr SUBOP expr	{ $$ = codetree.makebranch(SUB, $1, $3); }
		| expr MULOP expr	{ $$ = codetree.makebranch(MUL, $1, $3); }
		| expr DIVOP expr	{ $$ = codetree.makebranch(DIV, $1, $3); }
		| SUBOP expr		%prec MINUS
							{ $$ = codetree.makebranch(MIN, $2, 0); }
		| LP expr RP		{ $$ = $2; }
		| IDENT				{ $$ = codetree.makenode(ID, $1); }
		| NUMBER			{ $$ = codetree.makenode(NUM, $1); }
		| strcmp			{ $$ = $1;}
		| atoi				{ $$ = $1;}
		| date				{ $$ = $1;}
		| rand				{ $$ = $1;}
		;
strcpy	: STRCPYOP LP st RP
			{
				$$ = codetree.makebranch(STRCPY,$3,NULL);
			}
		;
strcat	: STRCATOP LP st RP
			{
				$$ = codetree.makebranch(STRCAT,$3,NULL);
			}
		;
strcmp	: STRCMPOP LP st RP
			{
				$$ = codetree.makebranch(STRCMP,$3,NULL);
			}
		;
sstpsend	: SSTPSENDOP LP str3 RP
			{
				$$ = codetree.makebranch(SSTPSEND,$3,NULL);
			}
		;
get_initfiledata	: GET_INITFILEDATAOP LP str RP
			{
				$$ = codetree.makebranch(GET_INITFILEDATA,$3,NULL);
			}
		;
atoi	: ATOIOP LP str RP
			{
				$$ = codetree.makebranch(ATOI,$3,NULL);
			}
		;
itoa	: ITOAOP LP expr RP
			{
				$$ = codetree.makebranch(ITOA,$3,NULL);
			}
		;
date	: DATEOP LP str RP
			{
				$$ = codetree.makebranch(DATE,$3,NULL);
			}
		;
rand	: RANDOP LP expr RP
			{
				$$ = codetree.makebranch(RAND,$3,NULL);
			}
		;
saoricall : SAORICALLOP LP stexst RP
			{
				$$ = codetree.makebranch(SAORICALL,$3,NULL);
			}
		;
save	: SAVEOP LP str RP
			{
				$$ = codetree.makebranch(SAVE,$3,NULL);
			}
		;
load	: LOADOP LP str RP
			{
				$$ = codetree.makebranch(LOAD,$3,NULL);
			}
		;
stexst	: stex CM str
			{ $$ = codetree.makebranch(NON, $1 ,$3); }
		;
stex	: str CM expr
			{ $$ = codetree.makebranch(NON, $1 ,$3); }
		;
str3	: str CM st
			{ $$ = codetree.makebranch(NON, $1 ,$3); }
		;
st		: str CM str
			{ $$ = codetree.makebranch(NON, $1 ,$3); }
		;
str		: STRING
			{ $$ = codetree.makenode(STR, $1); }
		| dimstr dim
			{ $$ = codetree.makebranch(DIM, $2, $1); }
		| dimstr
			{ $$ = codetree.makebranch(DIM, NULL, $1); }
		| IDENT
			{ $$ = codetree.makenode(ID, $1); }
		| get_initfiledata	{ $$ = $1;}
		| itoa				{ $$ = $1;}
		;
dimstr	: DIMM
			{ $$ = codetree.makenode(STR, $1); }
dim		: LB NUMBER RB
			{ $$ = codetree.makenode(NUM, $2); }
		;
%%
